/*
   name of the project:  SNAKE REBORN
   Version            :  1.0
   lab batch          :  371
   no of lines        :  541
*/
#include <assert.h>
#include "ezwin.h"
#include "bitmap.h"
#include <cstring>
#include <iostream>
#include <ctime>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>


using namespace std;
//defining windows 
SimpleWindow menu("SNAKE REBORN",12.0,9.00,Position(1.0,1.0));//main menu of the game
SimpleWindow mode("Mode",12.0,9.0,Position(1.0,1.0));//the selection of mode menu
SimpleWindow high("HIGH SCORES",12.0,9.00,Position(1.0,1.0));//highscores menu
SimpleWindow option("OPTIONS",12.0,9.00,Position(1.0,1.0));//the options menu
SimpleWindow info("INFO",12.0,9.00,Position(1.0,1.0));//the info menu
SimpleWindow game("THE GAME",12.0,9.00,Position(1.0,1.0));//the original game menu
SimpleWindow gameover("GameOver",12.0,9.0,Position(1.0,1.0));//the menu which is displayed at the end of the game 
SimpleWindow iscore("Instantaneous Score",6.0,2.0,Position(14.0,1.0));//the window showing the instantaneous scores
SimpleWindow Exit("Exit Reborn",12.0,9.0,Position(1.0,1.0));//the exit menu
SimpleWindow timeleft("        Time Left",6.0,2.0,Position(14.0,4.0));//the window showing the time left in the side 

//defining bitmaps
BitMap Menu(menu);// A Single bitmap for the menu window displaying various options
BitMap Option(option);//the bitmap of options
BitMap Instruction(info);//bitmap showing the instructions
BitMap Highscore(high);//bit map of thw word highscore
BitMap Body(game);//body of the snake
BitMap Fruit(game);//fruit in the snake game
BitMap Bonus(game);//bonus star in the snake game
BitMap Wall(game);//walls in the snake game
BitMap Head(game);//head of the snake
BitMap Yes(Exit);BitMap Yes1(gameover);//yes and no bitmaps
BitMap No(Exit);BitMap No1(gameover);
BitMap Back(info);//bitmaps to go to back
BitMap Back1(high);
BitMap Back2(option);
BitMap Default(option);
BitMap Classic(mode);
BitMap Arcade(mode);
BitMap Crazy(mode);


//defining variables
int level=9;int maze=1;/* the other in this line are sentinals */  int i;int f[4];char t[4];int temp;int hunt=0;int q[4];char l[4];
int highscores;int choose;//choose is the mode that you want to choose
float snake[420][2];//snake[420][0] displays the X Coordinate of the snake 
int length=4;//the initial length of the snake
char direction='r';//the direction in whch the snake is moving by default it is moving right
int randomx,b,randomy,randx,randy;//integers to take the random number
int count=1;int e;/*the variables used for count downtimer in arcade mode*/int arc=1;int arc1;
int score;int k=0;int maze1[24][18]; //score is the current score of the player and maze1 s the array in which the snake is present
int countbonus=40;//the ttime in which the bonus is being lost



//defining functions
int menuopen();//function to open the menu and defining the mouse click event in it
int clickonmenu(const Position &p);int modeclick(const Position &p);//definig the click on menu
int modeselect();//the player can chooose the mode in which he wants to play
int Highscores();//highscore function displaying the highscore
int highclick(const Position &p);//
int options();//displays the window and the bitmap
int optionclick(const Position &q);//defines clicking on the options menu
int exit();//exit funciton
int exitclick(const Position &p);//prompts us to exit or not
int infos();//info menu is displayed here
int start();// the function to start the game
int timer();// the tmer function which displays the speed of the snake and also the funcion to be repeated after the amount of time
int movingthesnake();//function to move the snake and also turn the snake
int mouseclick(const Position &r);//mouse click defines the funtion of moving the snake to the position you desire
int plotfruit();// funtion to plot the snake at the position you like but not on thhe snake or on the wall
int eat();				    // funtion to make the snake eat the fruit and grow 
int randomnumber(int l);		    //  defines a nmber number between interger 1 and the given integer
int MAZE1();				    //the function which displays the maze int the game
int killsnake();			   //function to kill the snake when it will go and hit itself or hit the wall
int scoredisplay();			   //function to display the instantaneous score of the player
int gameterminate();			   //function to terminate the game
int hscheck();				   //function to check weather the score of the player is more or less than the highscore
int Gameover();				  //function of the gameover option
int restart();				  // function to restart the gae if the player likes to continue
int gameoverclick (const Position &p);   // prompting the playerr to continue the game or not
                     
//defining the main function


int ApiMain()
{
	menuopen();
}

int menuopen()//telling it to open the menu load the menu  and set the mouse click
{
	menu.Open();
	menu.RenderText(Position(0.0,4.0),Position(12.0,5.0),"Loading..................",Red);
	Menu.Load("menu1.xpm");
	Menu.SetPosition(Position(0,0));
	Menu.Draw();
	menu.SetMouseClickCallback(clickonmenu);
	return 0;
}

int clickonmenu(const Position &p)// defining the mouse clicks
{
	
        if((p.GetXDistance()>0.828 && p.GetXDistance()<2.034)&&(p.GetYDistance()>6.348 && p.GetYDistance()<7.728))
		{
			start();
		}	
	else if((p.GetXDistance()>2.772 && p.GetXDistance()<4.236)&&(p.GetYDistance()>6.348 && p.GetYDistance()<7.728))
		{
			Highscores();	
		}
	else if((p.GetXDistance()>4.848 && p.GetXDistance()<6.432)&&(p.GetYDistance()>6.348&& p.GetYDistance()<7.728))
		{
			options();
		}
	else if((p.GetXDistance()>7.026 && p.GetXDistance()<8.658)&&(p.GetYDistance()>6.348 && p.GetYDistance()<7.728))
		{
			infos();
		}
	else if((p.GetXDistance()>9.21 && p.GetXDistance()<10.818)&&(p.GetYDistance()>6.348&& p.GetYDistance()<7.728))
		{
			exit();
		}
}

int exit()
{
  Exit.Open();
 Exit.RenderText(Position(0.0,2.0),Position(12.0,3.0),"Are You Sure You Want To Exit",Red);//will render the text of weather to exit or not
  Yes.Load("yes1.xpm");No.Load("no1.xpm");
   Yes.SetPosition(Position(2.0,4.0));No.SetPosition(Position(7.0,4.0));
   Yes.Draw();No.Draw();
  Exit.SetMouseClickCallback(exitclick);
}

int exitclick(const Position &p)
{ 
    //prompting weather to exit or not  
 if(p.GetXDistance()>2.0&&p.GetXDistance()<6.0&&p.GetYDistance()>4.0&&p.GetYDistance()<8.0){Exit.Close();menu.Close();}
 if(p.GetXDistance()>7.0&&p.GetXDistance()<11.0&&p.GetYDistance()>4.0&&p.GetYDistance()<8.0){Exit.Close();}

}

int Highscores()// the highscore function
{
	high.Open();
	Highscore.Load("highscore.xpm");
	Highscore.SetPosition(Position(4.0,2.0));
	Highscore.Draw();
  // reading the text file and displaying the the highscore previously stored in it which can be changed manually
  FILE *fhs1;int hs1;
  fhs1=fopen("hsversion1.txt","r");
   fscanf(fhs1, "%d",&hs1);
    highscores=hs1;
   fclose(fhs1);

   // here the text is in the string 
	f[3]=hs1%10;temp=hs1/10;f[2]=temp%10;temp=temp/10;f[1]=temp%10;temp=temp/10;f[0]=temp%10;
	for(e=0;e<4;e++)t[e]=(char)(48+f[e]);
	high.RenderText(Position(4.0,4.0), Position(8.0,5.0),t, Blue);
   Back1.Load("back.xpm");Back1.SetPosition(Position(5.0,6.0));Back1.Draw();
 high.SetMouseClickCallback(highclick); 
}

int highclick(const Position &p)
{ 
  if(p.GetXDistance()>5.0&&p.GetXDistance()<10.0&&p.GetYDistance()>6.0&&p.GetYDistance()<8.0){high.Close();}
  
}

// the options menu which prompt the user to choose the level in which he is playing

int options()
{  
 
	option.Open();
	Option.Load("levelmaze.xpm");
	Option.SetPosition(Position(0,0));
	Option.Draw();
	option.SetMouseClickCallback(optionclick);Back2.Load("back2.xpm");Back2.SetPosition(Position(8.57,4.65));Back2.Draw();
}

// Depending on the click of the user he can choose the level and maze that he likes

int optionclick(const Position &q)
{   cout<<q.GetXDistance()<<" "<<q.GetYDistance()<<endl;
	if((q.GetXDistance()>1.458 && q.GetXDistance()<2.094)&&(q.GetYDistance()>2.328&& q.GetYDistance()<3.66))
	{level=1;}

	if((q.GetXDistance()>2.52 && q.GetXDistance()<3.36)&&(q.GetYDistance()>2.328&& q.GetYDistance()<3.66))
	{level=2;}

	if((q.GetXDistance()>3.69 && q.GetXDistance()<4.32)&&(q.GetYDistance()>2.328&& q.GetYDistance()<3.66))
	{level=3;}

	if((q.GetXDistance()>4.68&& q.GetXDistance()<5.52)&&(q.GetYDistance()>2.328&& q.GetYDistance()<3.66))
	{level=4;}

	if((q.GetXDistance()>5.94 && q.GetXDistance()<6.66)&&(q.GetYDistance()>2.328&& q.GetYDistance()<3.786))
	{level=5;}

	if((q.GetXDistance()>6.96 && q.GetXDistance()<7.404)&&(q.GetYDistance()>2.328&& q.GetYDistance()<3.786))
	{level=6;}

	if((q.GetXDistance()>8.13&& q.GetXDistance()<8.76)&&(q.GetYDistance()>2.328&& q.GetYDistance()<3.66))
	{level=7;}

	if((q.GetXDistance()>9.12 && q.GetXDistance()<9.78)&&(q.GetYDistance()>2.328&& q.GetYDistance()<3.66))
	{level=8;}

	if((q.GetXDistance()>10.26&& q.GetXDistance()<10.86)&&(q.GetYDistance()>2.328&& q.GetYDistance()<3.66))
	{level=9;}

	if((q.GetXDistance()>1.458 && q.GetXDistance()<2.094)&&(q.GetYDistance()>6.9&& q.GetYDistance()<8.22))
	{maze=1;}

	if((q.GetXDistance()>2.52 && q.GetXDistance()<3.36)&&(q.GetYDistance()>6.9&& q.GetYDistance()<8.22))
	{maze=2;}

	if((q.GetXDistance()>3.69 && q.GetXDistance()<4.32)&&(q.GetYDistance()>6.9&& q.GetYDistance()<8.22))
	{maze=3;}

	if((q.GetXDistance()>4.68&& q.GetXDistance()<5.52)&&(q.GetYDistance()>6.9&& q.GetYDistance()<8.22))
	{maze=4;}

	if((q.GetXDistance()>5.94 && q.GetXDistance()<6.66)&&(q.GetYDistance()>6.9&& q.GetYDistance()<8.22))
	{maze=5;}

	if((q.GetXDistance()>6.96 && q.GetXDistance()<7.404)&&(q.GetYDistance()>6.9&& q.GetYDistance()<8.22))
	{maze=6;}

	if((q.GetXDistance()>8.13&& q.GetXDistance()<8.76)&&(q.GetYDistance()>6.9&& q.GetYDistance()<8.22))
	{maze=7;}

	if((q.GetXDistance()>9.12 && q.GetXDistance()<9.78)&&(q.GetYDistance()>6.9&& q.GetYDistance()<8.22))
	{maze=8;}

	if((q.GetXDistance()>10.26&& q.GetXDistance()<10.86)&&(q.GetYDistance()>6.9&& q.GetYDistance()<8.22))
	{maze=9;}

        if((q.GetXDistance()>8.56&& q.GetXDistance()<11.86)&&(q.GetYDistance()>4.5&& q.GetYDistance()<5.5))
	{option.Close();}

	cout<<"maze = "<<maze<<"  level = "<<level<<endl;

return 0;
}

int infos()
{
	info.Open();
	Instruction.Load("instructions.xpm");
	Instruction.SetPosition(Position(0,0));
	Instruction.Draw();
	return 0;
}




// starting the original game

int start()
{
	game.Open();menu.Close();
//opens the new window for the game to be played
	Body.Load("body.xpm");
	Head.Load("head.xpm");
	Body.SetPosition(Position(3.0,4.0));
	Body.Draw();
	game.SetTimerCallback(timer);// calling the timer function
	game.StartTimer(350-level*35);//this will give the speed for  the different level that the user choosed
      
   //to store highscore
   FILE *fhs2;FILE *fpout;int hs2;
  fhs2=fopen("hsversion1.txt","r");
   for(int h1=0;h1<4;h1++){fscanf(fhs2, "%d",&hs2);}
    highscores=hs2;fclose(fhs2);
  //storing the intitial coordinates of the snake

	snake[0][0]=5.0;snake[0][1]=4.0;snake[1][0]=4.5;snake[1][1]=4.0;snake[2][0]=4.0;snake[2][1]=4.0;snake[3][0]=3.5;snake[3][1]=4.0;
	game.SetMouseClickCallback(mouseclick);
	MAZE1();
}
// defining the mouse click events
 
int mouseclick(const Position &r)
{
    //if the direction of the snake is up or down then to change it, following code works:
	if(direction=='u'|| direction=='d')
	{
		//if the mouse click is to the left of the snake, then turn left
		if(r.GetXDistance()<snake[0][0])
		{
			direction='l';
		}
		//if the mouse click is to the right of the snake, then turn right
		else if(r.GetXDistance()>snake[0][0])
		{
			direction='r';
		}
	}
	//if the direction of the snake is left or right then to change it, following code works:
	else
	{
		//if the mouse click is above the snake, then turn upwards
		if(r.GetYDistance()<snake[0][1])
		{
			direction='u';
		}
		//if the mouse click is below the snake, then turn downwards 
		else if(r.GetYDistance()>snake[0][1])
		{
			direction='d';
		}
	}
	
	//move the snake
	movingthesnake();
        	
return 0;    	
	
	
	
}

// now this will be executed for every given number of milliseconds

int timer()
{
	movingthesnake();
	plotfruit();
	killsnake();
	scoredisplay();
}

int movingthesnake()
{	// this will transform the snake into new coordinates
 
	for(i=length-1;i>0;i=i-1){snake[i][0]=snake[i-1][0];snake[i][1]=snake[i-1][1];}//thanks for the excellent idea given by Nithin  hats off
	
	//thank you for vikash for giving this idea to turn the snake  by this code the snake turns to the direction we deserve
switch(direction)
	{
		//if snake goes upwards
		case 'u' : snake[0][1]=snake[0][1]-0.5;
		break;
		//if snake goes downwards
		case 'd' : snake[0][1]=snake[0][1]+0.5;
		break;
		//if snake goes left
		case 'l' : snake[0][0]=snake[0][0]-0.5;
		break;
		//if snake goes right
		case 'r' : snake[0][0]=snake[0][0]+0.5;
		break;
	}

// if the snake goes to the borders then it should return from the opposite 
	if(snake[0][0]==12.0)
		snake[0][0]=0;
	else if(snake[0][0]==-0.5)
		snake[0][0]=12.0;
	if(snake[0][1]==9.0)
		snake[0][1]=0;	
	else if(snake[0][1]==-0.5)
		snake[0][1]=9.0;

	Body.Erase();arc=arc+1;
	Head.SetPosition(Position(snake[0][0],snake[0][1]));
	Head.Draw();
 // will set the position of thhe body and draws it
	for(int j=1;j<length;j=j+1)
	{
		Body.SetPosition(Position(snake[j][0],snake[j][1]));
		Body.Draw();
	}
	eat();
	return 0;
}// function to plot the bonus fruit

int plotfruit()
{
  randx= randomnumber(24);
  randy= randomnumber(18);
 	if(count==1)
	{randomx=randx;randomy=randy;}
		count=count+1; 
	for(int g=0;g<length;g++){if(((float)randomx/2==snake[g][0] && (float)randomy/2==snake[g][1])||(maze1[randomx][randomy]==1)){randomx= randomnumber(24);randomy= randomnumber(18);g=0;}}
	// here the probability forr a bonus fruit  is minimum
	if(randomx%9==1 ||randomx%9==6){Fruit.Load("watermelon.xpm");}
	if(randomx%9==2 ||randomx%9==7){Fruit.Load("apple.xpm");}
	if(randomx%9==3 ||randomx%9==8){Fruit.Load("cherry.xpm");}
	if(randomx%9==4 ||randomx%9==0){Fruit.Load("orange.xpm");}
	if(randomx%9==5){Fruit.Load("bonus1.xpm");}
	Fruit.SetPosition(Position((float)randomx/2,(float)randomy/2));
	Fruit.Draw();countbonus=countbonus-1;// this will reduce the time for which the bonus fruit will appear
}

int eat()// this function will make the snake to increase its length  by the number of fruits it has eaten
{
  if (snake[0][0]==(float)randomx/2 && snake[0][1]==(float)randomy/2 &&randomx%9!=5)
	{length=length+1;Fruit.Erase();score=score+level;count=1;countbonus=40;
	if((snake[length-2][0]-snake[length-3][0])==0)
	 {if((snake[length-2][1]-snake[length-3][1])==0.5){snake[length-1][0]=snake[length-2][0];snake[length-1][1]=snake[length-2][1]+0.5;}
		else{snake[length-1][0]=snake[length-2][0];snake[length-1][1]=snake[length-2][1]-0.5;}
	}
	if((snake[length-2][1]-snake[length-3][1])==0)
	 {if((snake[length-2][0]-snake[length-3][0])==0.5){snake[length-1][1]=snake[length-2][1];snake[length-1][0]=snake[length-2][0]+0.5;}
		else{snake[length-1][1]=snake[length-2][1];snake[length-1][0]=snake[length-2][0]-0.5;}
 		
 	}
     }
  if((snake[0][0]==(float)randomx/2 && snake[0][1]==(float)randomy/2 && randomx%9==5 )||(randomx%9==5 && countbonus<=0))

       {Fruit.Erase();score=score+level*countbonus;count=1;countbonus=40;}
}

// for generating the random numbers
int randomnumber(int l)
{
	//seed value dependent on time
	srand(GetMilliseconds());
			
	//generating random co-ordinates			
  	return rand()%l;
}

// this function will read the text from the files and print the wall at the desired position
int MAZE1()
{
 	
	char a[12]="maze1.txt";
	FILE *fp;
	a[4]=(char)(48+maze);
	fp=fopen(a,"r");
	
	
	//load the wall where map array contains '1'
	
	for(int i1=0; i1<24; i1++)
	{
		for(int j1=0; j1<18; j1++)
		{
			fscanf(fp, "%d", &maze1[i1][j1]);
			if(maze1[i1][j1]==1)
			{	Wall.Load("wall.xpm");
				Wall.SetPosition(Position((float)i1/2, (float)j1/2));
				Wall.Draw();
			}
		}
	}
	fclose(fp);

	return 0;
}	

int killsnake()// this function will ki9ll the snake
{
  for(int y=1;y<length;y++){if(snake[0][0]==snake[y][0] && snake[0][1]==snake[y][1]){iscore.Close();game.StopTimer();/*game.Close();*/Gameover();hscheck();}
	int x=2*snake[0][0];int y=2*snake[0][1];
  if(maze1[x][y]==1){iscore.Close();/*game.Close()*/;Gameover();game.StopTimer();/*game.StartTimer(34000)*/hscheck();}}
  
}


int scoredisplay()//will display the instantaneous score of the player
{
    
	f[3]=score%10;temp=score/10;f[2]=temp%10;temp=temp/10;f[1]=temp%10;temp=temp/10;f[0]=temp%10;/*cout<<f[0]<<f[1]<<f[2]<<f[3]<<endl;*/
iscore.Open();
	for(e=0;e<4;e++)t[e]=(char)(48+f[e]);
	iscore.RenderText(Position(1.0,0.5), Position(5.0,1.5),t, Red);
//ignore if required
for(int y=1;y<length;y++){if(snake[0][0]==snake[y][0] && snake[0][1]==snake[y][1] ){iscore.Close();game.Close();}}
	int x=2*snake[0][0];int y=2*snake[0][1];
  if(maze1[x][y]==1){game.Close();iscore.Close();game.StopTimer();}

//upto here
  return 0;
}

int Gameover()// this wil open a new window if the game ends and will prompt us to play a new game 
{
  gameover.Open();
  
  if(score<highscores){gameover.RenderText(Position(0.0,2.0),Position(12.0,3.0),"OOPS you could not make the Highscore",Red);
                       gameover.RenderText(Position(0.0,3.0),Position(12.0,4.0),"Your Score",Blue);
			gameover.RenderText(Position(0.0,4.0),Position(12.0,5.0),t,Blue);
			gameover.RenderText(Position(0.0,5.0),Position(12.0,6.0),"Better Luck Next Time",Blue);}
if(score>=highscores){gameover.RenderText(Position(0.0,2.0),Position(12.0,4.0),"Wow you made a High score",Blue);
			gameover.RenderText(Position(0.0,3.0),Position(12.0,4.0),"Your Score",Blue);
			gameover.RenderText(Position(0.0,4.0),Position(12.0,5.0),t,Blue);}
  gameover.RenderText(Position(0.0,6.0),Position(12.0,7.0),"Do you want to have another game",Blue);
Yes1.Load("yes.xpm");No1.Load("no.xpm");Yes1.SetPosition(Position(2.0,7.0));No1.SetPosition(Position(6.0,7.0));Yes1.Draw();No1.Draw();
 gameover.SetMouseClickCallback(gameoverclick);
}

int gameoverclick (const Position &p)
{
   if(p.GetXDistance()>2.0&&p.GetXDistance()<5.0&&p.GetYDistance()>7.0&&p.GetYDistance()<9.0){restart();}
   if(p.GetXDistance()>6.0&&p.GetXDistance()<9.0&&p.GetYDistance()>7.0&&p.GetYDistance()<9.0){gameover.Close();menu.Close();mode.Close();}
}

int hscheck()// will check if you score is greater or less than the high score and store in it
{
  FILE *fpout;
  if(score>highscores)   
	{fpout = fopen ("hsversion1.txt", "w");
   fputs(t,fpout);
   fclose(fpout);}
}

int restart()
{   gameover.Close();
   mode.Close();
  
    cout<<maze<<" "<<level<<endl; 
         menuopen();
hunt=0;

length=4;
 direction='r';

count=1;
k=0;
 countbonus=40;score=0;
level=1; maze=1;
}
